> ## Documentation Index
> Fetch the complete documentation index at: https://docs.chainstack.com/llms.txt
> Use this file to discover all available pages before exploring further.

# eth_getFilterChanges | Cronos

Cronos API polling method used to retrieve updates from a filter. A filter is an object used to track changes to the state of the blockchain.

<Check>
  **Get your own node endpoint today**

  [Start for free](https://console.chainstack.com/) and get your app to production levels immediately. No credit card required.

  You can sign up with your GitHub, X, Google, or Microsoft account.
</Check>

Filters can be created using one of the following methods:

* [eth\_newFilter](/reference/cronos-newfilter)
* [eth\_newPendingTransactionFilter](/reference/cronos-newpendingtransactionfilter)
* [eth\_newBlockFilter](/reference/cronos-newblockfilter)

After creating a filter using one of the available methods, the resulting filter ID can be used to fetch changes by calling the `eth_getFilterChanges` method.

<Warning>
  **Disclaimer**

  Note that the default interactive example in this page will not work as the filter will be expired.

  To test `eth_getFilterChanges` in this page, first create a new filter using one of the following:

  * [eth\_newFilter](/reference/cronos-newfilter)
  * [eth\_newPendingTransactionFilter](/reference/cronos-newpendingtransactionfilter)
  * [eth\_newBlockFilter](/reference/cronos-newblockfilter)

  Then use the fresh filter ID as the parameter for `eth_getFilterChanges`.
</Warning>

## Parameters

* `string` — the filter ID of the filter for which you want to retrieve the changes

## Response

* `array` — an array that represents the changes that have occurred on the blockchain since the last time the filter was polled:
  * For filters created with `eth_newBlockFilter`:
    * `blockHash` — the hashes of the new blocks since the last time the filter was polled.
  * For filters created with `eth_newPendingTransactionFilter`:
    * `transactionHash` — the hashes identifying new pending transactions since the last time the filter was polled.
  * For filters created with `eth_newFilter`, the following event logs:
    * `address` — the contract address from which the event originated.
    * `topics` — an array of 32-byte data fields containing indexed event parameters.
    * `data` — the non-indexed data that was emitted along with the event.
    * `blocknumber` — the block number in which the event was included. `null` if it is pending.
    * `transactionhash` — the hash of the transaction that triggered the event. `null` if pending.
    * `transactionindex` — the integer index of the transaction within the block's list of transactions. `null` if it is pending.
    * `blockhash` — the hash of the block in which the event was included. `null` if it is pending.
    * `logindex` — the integer identifying the index of the event within the block's list of events. `null` if pending.
    * `removed` — the boolean value indicating if the event was removed from the blockchain due to a chain reorganization. `True` if the log was removed. `False` if it is a valid log.

## `eth_getFilterChanges` code examples

<Note>
  Note that the `web3.eth.filter` methods have been deprecated and replaced with the `web3.eth.subscribe` in web3.js. See [web3.js subscriptions](/reference/ethereum-web3js-subscriptions-methods).
</Note>

<CodeGroup>
  ```javascript ethers.js theme={"system"}
  const ethers = require('ethers');
  const NODE_URL = "CHAINSTACK_NODE_URL";
  const provider = new ethers.JsonRpcProvider(NODE_URL);

  async function getFilterChanges(filter) {
    try {
      const changes = await provider.send('eth_getFilterChanges', [filter]);
      console.log(changes); // Log the with the new data
    } catch (err) {
      console.error(err); // Handle errors that may occur
    }
  }

  const filterId =  '0x4e7ef166cd43f188b0f8f9e218966a8f' //'YOUR_FILTER_iD'
  getFilterChanges(filterId)
  ```

  ```python web3.py theme={"system"}
  from web3 import Web3  
  node_url = "CHAINSTACK_NODE_URL" 
  web3 = Web3(Web3.HTTPProvider(node_url))

  def get_filtered_events(filter_id):
      try:
          filter_changes = web3.eth.get_filter_changes(filter_id)
          print(filter_changes) # the array of events that match the filter
      except Exception as e:
          print(e)

  filter_id = '0x0'
  get_filtered_events(filter_id)       
  ```
</CodeGroup>

## Use case

The `eth_getFilterChanges` method can poll a filter to periodically retrieve new data. You can, for example, create a blocks filter using [eth\_newBlockFilter](/reference/cronos-newblockfilter) and periodically poll it to get new blocks.


## OpenAPI

````yaml /openapi/cronos_node_api/eth_getFilterChanges.json POST /b9b0fb92029d58b396139a9e89cf479b
openapi: 3.0.0
info:
  title: Cronos Node API
  version: 1.0.0
  description: This is an API for interacting with a Cronos node.
servers:
  - url: https://nd-907-114-772.p2pify.com
security: []
paths:
  /b9b0fb92029d58b396139a9e89cf479b:
    post:
      summary: eth_getFilterChanges
      operationId: getFilterChanges
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                jsonrpc:
                  type: string
                  default: '2.0'
                method:
                  type: string
                  default: eth_getFilterChanges
                params:
                  type: array
                  items:
                    type: string
                    title: The filter ID
                  default:
                    - '0xbdc5b4b99ca699e1d734fc4202afee79'
                id:
                  type: integer
                  default: 1
      responses:
        '200':
          description: The filter changes.
          content:
            application/json:
              schema:
                type: object
                properties:
                  jsonrpc:
                    type: string
                  id:
                    type: integer
                  result:
                    type: array
                    items:
                      type: string

````